import { ReactNode } from 'react';
import { Editor } from 'slate';
import { SlatePlugin } from '../types/SlatePlugin/SlatePlugin';
import { WithOverride } from '../types/SlatePlugin/WithOverride';
import { SlatePluginsOptions } from '../types/SlatePluginOptions/SlatePluginsOptions';
export interface SlatePluginsEditor extends Editor {
    key: any;
    id: string;
    options: SlatePluginsOptions;
}
export interface WithSlatePluginsOptions {
    id?: string;
    plugins?: SlatePlugin[];
    options?: SlatePluginsOptions;
    components?: Record<string, ReactNode>;
}
/**
 * Apply `withInlineVoid` and all slate plugins `withOverrides`.
 * Overrides:
 * - `id`: id of the editor.
 * - `key`: random key for the <Slate> component so each time the editor is created, the component resets.
 * - `options`: {@link SlatePluginsOptions}
 */
export declare const withSlatePlugins: <TOutput = {}>({ id, plugins, options, components, }?: WithSlatePluginsOptions) => WithOverride<import("slate").BaseEditor, SlatePluginsEditor & TOutput>;
/**
 * @see {@link withSlatePlugins}
 */
export declare const useSlatePluginsPlugin: (options?: WithSlatePluginsOptions | undefined) => SlatePlugin;
//# sourceMappingURL=useSlatePluginsPlugin.d.ts.map